<?php 
/*
 * AJAX Gallery: Remove Album / Item
 * For the purpose of this demo, this file will only return a fictional result, 
 * but you'll probably want to remove the album/item from a database, process data validation, remove the actual files, etc.
 * must return a JSON encoded string with required params:
 * 
 * errors = (boolean) true/false;
 * errorMsg = (string) "some error message string";
 */

// to be returned as encoded JSON string
$return = array();

// default no errors & empty error message
$errors = false;
$errorMsg = "";

// our item / album ID to be removed
$rel_id = isset($_POST['rel_id']) && $_POST['rel_id'] != '' && $_POST['rel_id'] != 'undefined' ? $_POST['rel_id'] : false;
if (!$rel_id)
{
	$errors = true;
	$errorMsg = "Invalid request";
}

if (!$errors):

// item or album removal
$type = isset($_POST['type']) ? $_POST['type'] : false;

// your logic by type of removal
switch ($type)
{
	default: 
		// no type specified
		$errors = true;
		$errorMsg = "Invalid removal";
		break;
		
	case 'item':
		// item removal logic
		$album_id = isset($_POST['album_id']) && $_POST['album_id'] != '' && $_POST['album_id'] != 'undefined' ? $_POST['album_id'] : false;
		$album_id = isset($_GET['album_id']) && $_GET['album_id'] != '' && $_GET['album_id'] != 'undefined' ? $_GET['album_id'] : $album_id;
		
		if (!$album_id)
		{
			$errors = true;
			$errorMsg = 'Album missing.';
			break;
		}
		
		// demo only
		if (GALLERY_DEMO && in_array($album_id, array(1,2,3)))
		{
			$errors = true;
			$errorMsg = "This demo allows you to delete Items only from Albums created by you.";
			break;
		}
		
		$album_path = $album_id ? $album_id . '/' : '';
		$files = array(
			$_SERVER['DOCUMENT_ROOT'] . GALLERY_PATH . "{$album_path}files/{$rel_id}",
			$_SERVER['DOCUMENT_ROOT'] . GALLERY_PATH . "{$album_path}thumbnails/{$rel_id}"
		);
		foreach ($files as $file)
		{
			if (!file_exists($file))
			{
				$errors = true;
				$errorMsg = 'File missing.';
				break;
			}
			unlink($file);
		}
		break;
		
	case 'album':
		// demo only
		if (GALLERY_DEMO && in_array($rel_id, array(1,2,3)))
		{
			$errors = true;
			$errorMsg = "This demo allows you to delete only Albums created by you.";
			break;
		}
		
		// album removal logic
		$album_path = $rel_id . '/';
		$dirs = array(
            $_SERVER['DOCUMENT_ROOT'] . GALLERY_PATH . "{$album_path}files/",
            $_SERVER['DOCUMENT_ROOT'] . GALLERY_PATH . "{$album_path}thumbnails/"
		);
		foreach ($dirs as $dir)
		{
			$files = file_exists($dir) ? array_diff(scandir($dir), array('.', '..')) : array();
			foreach ($files as $file)
			{
				unlink($dir.$file);
			}
			@rmdir($dir);
		}
		@rmdir($_SERVER['DOCUMENT_ROOT'] . GALLERY_PATH . $album_path);
		break;
}

endif; 

/* uncomment to simulate an error
 * 
 $errors = true;
 $errorMsg = "some nasty error occurred";
*/

// include errors from processing above in the result
$return['errors'] = $errors;
$return['errorMsg'] = $errorMsg;

// return JSON encoded string
echo json_encode($return);