<?PHP
/*
========================================
 Agent Shop CMS 
----------------------------------------
 http://ascms.ru/
----------------------------------------
 Copyright (c) Дмитрий Дьяконов
----------------------------------------
 Данный код защищен авторскими правами
========================================
*/

/* Получение категорий */

function Category($sctimemenu, $guid_agent, $cat, $savecache)
{
    global $curl;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_TIMEOUT, 30);
    $load = true;
    $result = '';
    if ($savecache == '1') {
        if (file_exists("cache/menu/" . $cat . ".xml")) {
            $result = file_get_contents("cache/menu/" . $cat . ".xml");
            $result = explode("\n", $result);
            if ((time() - $result[0]) < $sctimemenu * 60) {
                $result = $result[2];
                $load = false;
            }
        }
    }
    if ($load) {
        curl_setopt($curl, CURLOPT_URL, 'http://www.plati.ru/xml/sections.asp');
        $xml = "<digiseller.request><guid_agent>" . $guid_agent . "</guid_agent><id_catalog>" . $cat . "</id_catalog></digiseller.request>";
        curl_setopt($curl, CURLOPT_POSTFIELDS, $xml);
        $result = curl_exec($curl);
        if ($savecache == '1') {
            file_put_contents("cache/menu/" . $cat . ".xml", time() . "\n\n" . $result);
        }
    }
    return $result;
}

/* Получение товаров категорий */

function Goods($guid_agent, $cat, $page, $page_rows, $curr, $order, $savecachetime, $savecache)
{
    global $curl, $val_c, $val_p, $val_o;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_TIMEOUT, 30);
    $load = true;
    $result = '';
    if ($savecache == '1') {
        if ($curr == $val_c and $page_rows == $val_p and $order == $val_o) {
            if (file_exists("cache/list/" . $cat . "-" . $page . ".xml")) {
                $result = file_get_contents("cache/list/" . $cat . "-" . $page . ".xml");
                $result = explode("\n", $result);
                if ((time() - $result[0]) < $savecachetime * 60) {
                    $result = $result[2];
                    $load = false;
                }
            }
        }
    }
    if ($load) {
        curl_setopt($curl, CURLOPT_URL, 'http://www.plati.ru/xml/goods.asp');
        $xml = '<digiseller.request><guid_agent>' . $guid_agent . '</guid_agent><id_section>' . $cat . '</id_section><page>' . $page . '</page><rows>' . $page_rows . '</rows><currency>' . $curr . '</currency><order>' . $order . '</order></digiseller.request>';
        curl_setopt($curl, CURLOPT_POSTFIELDS, $xml);
        $result = curl_exec($curl);
        $result = str_replace('&amp;', '&', $result);
        $result = str_replace('<![CDATA[', '', $result);
        $result = str_replace(']]>', '', $result);
        if ($savecache == '1') {
            if ($curr == $val_c and $page_rows == $val_p and $order == $val_o) {
                file_put_contents("cache/list/" . $cat . "-" . $page . ".xml", time() . "\n\n" . $result);
            }
        }
    }
    return $result;
}

/* Получение информации о товаре */

function GoodsInfo($guid_agent, $id, $savecachetime, $savecache)
{
    global $curl;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_TIMEOUT, 30);
    $load = true;
    $result = '';
    if ($savecache == '1') {
        if (file_exists("cache/pay/" . $id . ".xml")) {
            $result = file_get_contents("cache/pay/" . $id . ".xml");
            $result = explode(";*;", $result);
            if ((time() - $result[0]) < $savecachetime * 60) {
                $result = $result[1];
                $load = false;
            }
        }
    }
    if ($load) {
        curl_setopt($curl, CURLOPT_URL, 'http://www.plati.ru/xml/goods_info.asp');
        $xml = '<digiseller.request><guid_agent>' . $guid_agent . '</guid_agent><id_goods>' . $id . '</id_goods></digiseller.request>';
        curl_setopt($curl, CURLOPT_POSTFIELDS, $xml);
        $result = curl_exec($curl);
        $result = str_replace('&amp;', '&', $result);
        $result = str_replace('<![CDATA[', '', $result);
        $result = str_replace(']]>', '', $result);
        if ($savecache == '1') {
            file_put_contents("cache/pay/" . $id . ".xml", time() . ";*;" . $result);
        }
    }
    return $result;
}

/* Получение информации о продавце */

function SellerInfo($guid_agent, $id, $savecachetime, $savecache)
{
    global $curl;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_TIMEOUT, 30);
    $load = true;
    $result = '';
    if ($savecache == '1') {
        if (file_exists("cache/seller/" . $id . ".xml")) {
            $result = file_get_contents("cache/seller/" . $id . ".xml");
            $result = explode(";*;", $result);
            if ((time() - $result[0]) < $savecachetime * 60) {
                $result = $result[1];
                $load = false;
            }
        }
    }
    if ($load) {
        curl_setopt($curl, CURLOPT_URL, 'http://www.plati.ru/xml/seller_info.asp');
        $xml = '<digiseller.request><guid_agent>' . $guid_agent . '</guid_agent><id_seller>' . $id . '</id_seller></digiseller.request>';
        curl_setopt($curl, CURLOPT_POSTFIELDS, $xml);
        $result = curl_exec($curl);
        $result = str_replace('&amp;', '&', $result);
        $result = str_replace('<![CDATA[', '', $result);
        $result = str_replace(']]>', '', $result);
        if ($savecache == '1') {
            file_put_contents("cache/seller/" . $id . ".xml", time() . ";*;" . $result);
        }
    }
    return $result;
}

/* Получение отзывов о товаре */

function Responses($guid_agent, $id_seller, $id, $page, $resp_rows, $savecachetime, $savecache)
{
    global $curl, $val;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_TIMEOUT, 30);
    $load = true;
    $result = '';
    if ($savecache == '1') {
        if ($resp_rows == $val) {
            if (file_exists("cache/responses/" . $id . "-" . $page . ".xml")) {
                $result = file_get_contents("cache/responses/" . $id . "-" . $page . ".xml");
                $result = explode(";*;", $result);
                if ((time() - $result[0]) < $savecachetime * 60) {
                    $result = $result[1];
                    $load = false;
                }
            }
        }
    }
    if ($load) {
        curl_setopt($curl, CURLOPT_URL, 'http://www.plati.ru/xml/responses.asp');
        $xml = '<digiseller.request><guid_agent>' . $guid_agent . '</guid_agent><id_seller>' . $id_seller . '</id_seller><id_goods>' . $id . '</id_goods><type_response></type_response><page>' . $page . '</page><rows>' . $resp_rows . '</rows></digiseller.request>';
        curl_setopt($curl, CURLOPT_POSTFIELDS, $xml);
        $result = curl_exec($curl);
        $result = str_replace('&amp;', '&', $result);
        $result = str_replace('<![CDATA[', '', $result);
        $result = str_replace(']]>', '', $result);
        if ($savecache == '1') {
            if ($resp_rows == $val) {
                file_put_contents("cache/responses/" . $id . "-" . $page . ".xml", time() . ";*;" . $result);
            }
        }
    }
    return $result;
}

/* Получение товаров продавца */

function SellerGoods($guid_agent, $id, $page, $sell_rows, $curr, $order, $savecachetime, $savecache)
{
    global $curl, $val;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_TIMEOUT, 30);
    $load = true;
    $result = '';
    if ($savecache == '1') {
        if ($sell_rows == $val) {
            if (file_exists("cache/list/" . $id . "-" . $page . ".xml")) {
                $result = file_get_contents("cache/list/" . $id . "-" . $page . ".xml");
                $result = explode(";*;", $result);
                if ((time() - $result[0]) < $savecachetime * 60) {
                    $result = $result[1];
                    $load = false;
                }
            }
        }
    }

    if ($load) {
        curl_setopt($curl, CURLOPT_URL, 'http://www.plati.ru/xml/seller_goods.asp');
        $xml = '<digiseller.request><guid_agent>' . $guid_agent . '</guid_agent><id_seller>' . $id . '</id_seller><page>' . $page . '</page><rows>' . $sell_rows . '</rows><currency>' . $curr . '</currency><order>' . $order . '</order></digiseller.request>';
        curl_setopt($curl, CURLOPT_POSTFIELDS, $xml);
        $result = curl_exec($curl);
        $result = str_replace('&amp;', '&', $result);
        $result = str_replace('<![CDATA[', '', $result);
        $result = str_replace(']]>', '', $result);
        if ($savecache == '1') {
            if ($sell_rows == $val) {
                file_put_contents("cache/list/" . $id . "-" . $page . ".xml", time() . ";*;" . $result);
            }
        }
    }
    return $result;
}

/* Запись выбранных товаров в блокнот */

function checked($id)
{
    $ip = $_SERVER["REMOTE_ADDR"];
    if (!is_dir("cache/note/$ip")) {
        mkdir("cache/note/$ip");
    }
    $list = scandir("cache/note/$ip/");
    unset($list[0]);
    unset($list[1]);
    foreach ($list as $value) {
        $id_ = str_replace(".txt", "", $value);
        if ($id_ == $id) {
            return "checked";
        }
    }
}

/* Поиск товара */
function Search($guid_agent, $search_str, $page, $page_rows)
{
    global $curl;
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_TIMEOUT, 30);
    curl_setopt($curl, CURLOPT_URL, 'http://www.plati.ru/xml/search_goods.asp');
    $xml = '<digiseller.request><guid_agent>' . $guid_agent . '</guid_agent><search_str>' . $search_str . '</search_str><check_words>$check_words</check_words>	<cnt_goods>1000</cnt_goods><page>' . $page . '</page><rows>' . $page_rows . '</rows></digiseller.request>';
    curl_setopt($curl, CURLOPT_POSTFIELDS, $xml);
    $result = curl_exec($curl);
    $result = str_replace('&amp;', '&', $result);
    $result = str_replace('<![CDATA[', '', $result);
    $result = str_replace(']]>', '', $result);
    return $result;
}

/* Парсер XML */

function XMLtag($tag, $Memory)
{

    $L = strlen($tag);
    $n1 = 0;

    do {
        $n1 = strpos($Memory, "<$tag", $n1);
        if ($n1 === false) {
            return 0;
        }
        $u = substr($Memory, $n1 + $L + 1, 1);

        $n1 = $n1 + 1;
    } while ($u <> ">" and $u <> " ");


    $b = strpos($tag, " ");
    if ($b <> 0) {
        $tag = substr($tag, 0, $b);
    }

    $n2 = strpos($Memory, ">", $n1);
    $n3 = strpos($Memory, "</$tag>", $n2);
    if ($n3 == 0) {
        return 0;
    }


    return substr($Memory, $n2 + 1, $n3 - $n2 - 1);
}

/* ЧПУ URL */

function TranslitUrl($str)
{
    $str = preg_replace('~[^А-яA-z0-9_]+~u', '-', $str);
    $str = trim($str, "-");
    $str = mb_strtolower($str, 'UTF-8');
    $tr = array(
        "А" => "a", "Б" => "b", "В" => "v", "Г" => "g", "Д" => "d", "Е" => "e", "Ж" => "j", "З" => "z", "И" => "i", "Й" => "y", "К" => "k", "Л" => "l", "М" => "m", "Н" => "n",
        "О" => "o", "П" => "p", "Р" => "r", "С" => "s", "Т" => "t", "У" => "u", "Ф" => "f", "Х" => "h", "Ц" => "ts", "Ч" => "ch", "Ш" => "sh", "Щ" => "sch", "Ъ" => "", "Ы" => "yi", "Ь" => "",
        "Э" => "e", "Ю" => "yu", "Я" => "ya", "а" => "a", "б" => "b", "в" => "v", "г" => "g", "д" => "d", "е" => "e", "ж" => "j", "з" => "z", "и" => "i", "й" => "y", "к" => "k", "л" => "l",
        "м" => "m", "н" => "n", "о" => "o", "п" => "p", "р" => "r", "с" => "s", "т" => "t", "у" => "u", "ф" => "f", "х" => "h", "ц" => "ts", "ч" => "ch", "ш" => "sh", "щ" => "sch", "ъ" => "y",
        "ы" => "yi", "ь" => "", "э" => "e", "ю" => "yu", "я" => "ya", "_" => "" , "]" => "" , "[" => ""
    );
    return strtr($str, $tr);
}


/* Навигация по списку товаров / отзывов */

function Navigation($max, $page, $pages, $strURI)
{
    $strReturn = '<div class="pagination"><ul>';
    $left = false;
    $right = false;


    $page = (intval($page) > 0) ? intval($page) : 1;

    if ($page > 1) {
        $strReturn .= '<li><a href="'.$strURI. ($page - 1).'">&laquo; Назад</a></li>';

    } else {

        $strReturn .= '<li class="disabled"><span> Назад</span></li>';

    }

    if ($pages <= $max) {
        for ($i = 1; $i <= $pages; $i++) {
            if ($i == $page) {
                $strReturn .= '<li class="active"><span>' . $page . '</span></li>';

            } else
            {
                $strReturn .= '<li><a href="'.$strURI.$i.'">' . $i . '</a></li>';
            }
        }
    } else {

        for ($i = 1; $i <= $pages; $i++) {

            if (($i == $page) OR ($i == $page - 1) OR ($i == $page - 2)  OR ($i == $page - 3) OR ($i == $page - 4) OR ($i == $page + 1) OR
                ($i == $page + 2)  OR ($i == $page + 3) OR ($i == $page + 4))
            {

                if ($i == $page) {

                    $strReturn .= '<li class="active"><span>' . $page . '</span></li>';

                } else {

                    $strReturn .= '<li><a href="'.$strURI.$i.'">' . $i . '</a></li>';

                }

            } else {

                if ($i > $page) {

                    if(!$right){

                        if ($page <= $pages - 6) {

                        $strReturn .= '<li><span class="dotes">...</span></li><li><a href="'.$strURI.$pages.'">' . $pages . '</a></li>';
                            $right = true;
                    } else {

                        $strReturn .= '<li><a href="'.$strURI.$pages.'">' . $pages . '</a></li>';
                            $right = true;

                    }
                    }


                } else {
                    if(!$left){

                        if ($page > 6) {

                        $strReturn .= '<li><a href="' . $strURI . '1">1</a></li><li><span class="dotes">...</span></li>';
                            $left = true;
                    } else {

                        $strReturn .= '<li><a href="' . $strURI . '1">1</a></li>';
                            $left = true;
                    }
                    }
                }
            }
        }

    }
    if ($page < $pages) {

        $strReturn .= '<li><a href="'.$strURI.($page + 1).'">Вперед &raquo;</a></li>';

    } else {

        $strReturn .= '<li class="disabled"><span>Вперед</span></li>';

    }
    $strReturn .= '</ul></div>';
    return $strReturn;
}

/* Название категории */

function CatName($id)
{

    $Names = array(1 => "Электронные книги", 2 => "Программное обеспечение", 10 => "PIN-коды", 138 => "Цифровые товары");
    return (strlen($Names[$id]) > 0) ? $Names[$id] : "Undefined";
}

/* Получение параметров XML тега */

function TagParam($tag, &$Memory, &$start)
{
    $s = strpos($Memory, $tag . '="', $start);
    if ($s == "") {
        return $TagParam;
    }
    $s = $s + strlen($tag) + 2;
    $e = strpos($Memory, '"', $s);
    $TagParam = substr($Memory, $s, $e - $s);
    $start = $e + 1;
    return $TagParam;
}

function getPagination($page, $per_page, $pages, $uri)
{
    global $seourl;
        if ($seourl == 1){
            $struri = $uri.'page/';
        }
        else{
            $struri = $uri.'?p=';
        }
    $pagination = '<div class="pagination"><ul>';
    $max = ceil($pages / $per_page);

    $page = (intval($page) > 0) ? intval($page) : 1;

    if ($page > 1) {
        $pagination .= '<li><a href="'.$struri. ($page - 1) .'">&laquo; Назад</a></li>';

    } else {

        $pagination .= '<li class="disabled"><span> Назад</span></li>';

    }

    for ($i = 1; $i <= $max; $i++) {

        if ($i == $page) {
            $active = '<li class="active"><span>'.$i.'</span></li>';
        }
        else{
            if ($i == 1){
                $active = '<li><a href="'.$uri.'">'.$i.'</a></li>';
            }else{
                $active = '<li><a href="'.$struri.$i.'">'.$i.'</a></li>';
            }
        }

        $pagination .= $active;

    }

    if ($page < $max) {

        $pagination .= '<li><a href="'.$struri.($page + 1).'">Вперед &raquo;</a></li>';

    } else {

        $pagination .= '<li class="disabled"><span>Вперед</span></li>';

    }


    $pagination .= '</ul></div>';
    return $pagination;
}

function get_keywords($text)
{
    $search = array("'ё'",
        "'<script[^>]*?>.*?</script>'si",
        "'<[\/\!]*?[^<>]*?>'si",
        "'([\r\n])[\s]+'",
        "'&(quot|#34);'i",
        "'&(amp|#38);'i",
        "'&(lt|#60);'i",
        "'&(gt|#62);'i",
        "'&(nbsp|#160);'i",
        "'&(iexcl|#161);'i",
        "'&(cent|#162);'i",
        "'&(pound|#163);'i",
        "'&(copy|#169);'i",
        "'&#(\d+);'e");
    $replace = array("е",
        " ",
        " ",
        "\\1 ",
        "\" ",
        " ",
        " ",
        " ",
        " ",
        chr(161),
        chr(162),
        chr(163),
        chr(169),
        "chr(\\1)");
    $text = str_replace($search, $replace, $text);
    $del_symbols = array(",", ".", ";", ":", "\"", "#", "\$", "%", "^",
        "!", "@", "`", "~", "*", "-", "=", "+", "\\",
        "|", "/", ">", "<", "(", ")", "&", "?", "¹", "\t",
        "\r", "\n", "{", "}", "[", "]", "'", "“", "”", "•",
        "как", "для", "что", "или", "это", "этих",
        "всех", "вас", "они", "оно", "еще", "когда",
        "где", "эта", "лишь", "уже", "вам", "нет",
        "если", "надо", "все", "так", "его", "чем",
        "при", "даже", "мне", "есть", "раз", "два",
        "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"
    );
    $text = str_replace($del_symbols, array(" "), $text);
    $text = preg_replace("( +)", " ", $text);
    $text = explode(" ", trim($text));
    $tmp_arr = array();
    foreach ($text as $val) {
        if (strlen($val) >= 5) {
            $val = mb_strtolower($val, 'UTF-8');
            if (isset($val, $tmp_arr)) {
                $tmp_arr[$val]++;
            } else {
                $tmp_arr[$val] = 1;
            }
        }
    }
    arsort($tmp_arr);
    $text = $tmp_arr;
    $arr = array_slice($text, 0, 7);
    foreach ($arr as $key => $val) {
        $str .= $key . ", ";
    }
    return trim(substr($str, 0, strlen($str)));
}


$ip = $_SERVER["REMOTE_ADDR"];
$cnt_note = 0;
if (file_exists("cache/note/$ip")) {
    $cnt_note = count(scandir("cache/note/$ip/")) - 2;
}
?>